// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Stage.h"
#include "MainFrm.h"
#include "indevdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ACTIVATEAPP()
	ON_WM_PALETTECHANGED()
	ON_WM_MOVE()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_EDIT_INSERTSHAPE, OnEditInsertShape)
	ON_COMMAND(ID_EDIT_TRANSFORM, OnEditTransform)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TRANSFORM, OnUpdateEditTransform)
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_EDIT_CONTROL, OnEditControl)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CONTROL, OnUpdateEditControl)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SELECTION, OnUpdateViewSelection)
	ON_COMMAND(ID_VIEW_SELECTION, OnViewSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETESHAPE, OnUpdateEditDeleteshape)
	ON_COMMAND(ID_EDIT_DELETESHAPE, OnEditDeleteshape)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COLOR, OnUpdateEditColor)
	ON_COMMAND(ID_EDIT_COLOR, OnEditColor)
	ON_COMMAND(ID_EDIT_BKGNDIMG, OnEditBkgndImg)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RANDCOLOR, OnUpdateEditRandcolor)
	ON_COMMAND(ID_EDIT_RANDCOLOR, OnEditRandcolor)
	ON_COMMAND(ID_EDIT_INSTXFACE, OnEditInstxface)
	ON_COMMAND(ID_EDIT_INSWORLD, OnEditInsworld)
	ON_COMMAND(ID_EDIT_PICCUBE, OnEditPiccube)
	ON_COMMAND(ID_EDIT_TREE, OnEditTree)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLONE, OnUpdateEditClone)
	ON_COMMAND(ID_EDIT_CLONE, OnEditClone)
	ON_COMMAND(ID_EDIT_HOUSE, OnEditHouse)
	ON_COMMAND(ID_EDIT_INPUTDEV, OnEditInputdev)
	ON_COMMAND(ID_EDIT_CLRFRAME, OnEditClrframe)
	ON_COMMAND(ID_EDIT_MATERIALS, OnEditMaterials)
	ON_COMMAND(ID_EDIT_CHROME, OnEditChrome)
	ON_COMMAND(ID_EDIT_TANK, OnEditTank)
	ON_COMMAND(ID_FILE_SAVE_IMAGE, OnFileSaveImage)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_OBJECT, OnUpdateFileSaveObject)
	ON_COMMAND(ID_FILE_SAVE_OBJECT, OnFileSaveObject)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pScene = NULL;
	m_pCurShape = FALSE;
	m_pTransDlg = NULL;
	m_pController = NULL;
	m_iObjCtrlDev = 0;
	m_iControlObj = 0;
	m_iControlType = 0;
	m_pSelBox = NULL;
	m_pChromeWrap = NULL;
}

CMainFrame::~CMainFrame()
{
	if (m_pChromeWrap) delete m_pChromeWrap;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Create the 3D window
	if (!m_wnd3d.Create(this, IDC_3DWND)) {
		return -1;
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	NewScene();
	ASSERT(m_pScene);

	// Create the controller object
	if (m_iControlType == 0) {
		m_pController = new C3dPosCtlr;
	} else {
		m_pController = new C3dFlyCtlr;
	}
	m_pController->Create(&m_wnd3d,
						  OnGetCtrlFrame,
					      this);

	// restore the controller settings
	m_pController->SelectDevice(m_iObjCtrlDev);

	// enable mouse selection of objects
	m_wnd3d.EnableMouseSelection(OnSelChange, this);
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// Restore any saved settings
	RestoreSettings();

	// Restore the window size and position
	cs.x = m_rcWnd.left;
	cs.y = m_rcWnd.top;
	cs.cx = m_rcWnd.Width();
	cs.cy = m_rcWnd.Height();

	return CFrameWnd::PreCreateWindow(cs);
}

BOOL CMainFrame::NewScene()
{
	HideSelection();

	// Delete any scene we might have
	if (m_pScene) {
		m_wnd3d.SetScene(NULL);
		delete m_pScene;
		m_pScene = NULL;
	}
	MakeCurrent(NULL);

	if (m_pChromeWrap) {
		delete m_pChromeWrap;
		m_pChromeWrap = NULL;
	}

	// Create an initial scene
	m_pScene = new C3dScene;
	if (!m_pScene->Create()) return FALSE;

	// Set up the lighting
    C3dDirLight dl;
    dl.Create(0.8, 0.8, 0.8);
    m_pScene->AddChild(&dl);
    dl.SetPosition(-2, 2, -5);
    dl.SetDirection(1, -1, 1);
    m_pScene->SetAmbientLight(0.4, 0.4, 0.4);

	// reset the camera position and direction
    m_pScene->SetCameraPosition(C3dVector(0, 0, -10));
    m_pScene->SetCameraDirection(C3dVector(0, 0, 1), C3dVector(0, 1, 0));


	m_wnd3d.SetScene(m_pScene);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();

	// Save the current settings
	SaveSettings();
	
	// remove any selection box
	HideSelection();

	// shut down any modeless dialogs
	if (m_pTransDlg) {
		m_pTransDlg->DestroyWindow();
	}

	// destroy the controller
	if (m_pController) {
		delete m_pController;
		m_pController = NULL;
	}

	// Delete any scene we might have
	m_wnd3d.SetScene(NULL);
	if (m_pScene) {
		delete m_pScene;
		m_pScene = NULL;
	}
	MakeCurrent(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// window layout handler

void CMainFrame::RecalcLayout(BOOL bNotify) 
{
    // Rearrange the control bars and fit the 3D window in the middle
	// Let the frame rearrange the control bars
	CFrameWnd::RecalcLayout(bNotify);

	// Find the space that's left over
	CRect rc;
	RepositionBars(0,
				   0xFFFF,
				   IDC_3DWND,
				   CWnd::reposQuery,
				   &rc);
	if (IsWindow(m_wnd3d.GetSafeHwnd())) {
		m_wnd3d.MoveWindow(&rc, FALSE);
	}
}


///////////////////////////////////////////////////////////////
// Windows messages we need to handle

void CMainFrame::OnActivateApp(BOOL bActive, HTASK hTask) 
{
	CFrameWnd::OnActivateApp(bActive, hTask);
	
	// Tell the 3D window about the new state
	m_wnd3d.SendMessage(WM_ACTIVATEAPP,
						(WPARAM)bActive,
						(LPARAM)hTask);
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	// Let the 3D window know
	m_wnd3d.SendMessage(WM_PALETTECHANGED,
					   pFocusWnd ? (WPARAM)pFocusWnd->GetSafeHwnd() : 0);
}

void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
	// Let the 3D window know the frame has moved
	m_wnd3d.SendMessage(WM_MOVE, 0, MAKELPARAM(0, 0));
}

///////////////////////////////////////////////////////////////
// Adding new objects

void CMainFrame::OnFileNew() 
{
	NewScene();
}

BOOL CMainFrame::OpenFile(const char* pszPath)
{
	// Create a new scene
	NewScene();
	ASSERT(m_pScene);

	// Try for a shape file
	C3dShape* pShape = new C3dShape;
	const char* pszFile = pShape->Load(pszPath);
	if (!pszFile) {
		delete pShape;
		return FALSE;
	}


	// Attach the new shape to the scene
	m_pScene->AddChild(pShape);

	// Add it to the shape list
	m_pScene->m_ShapeList.Append(pShape);

	// Make it the current shape
	MakeCurrent(pShape);

	// Add the name to the recent file list
	AfxGetApp()->AddToRecentFileList(pszFile);
	Status("Opened: %s", pszFile);
	return TRUE;
}

void CMainFrame::OnFileOpen() 
{
	OpenFile(NULL);
}

void CMainFrame::OnEditInsertShape() 
{
	CShapeDlg dlg("Insert Shape", this);

	if (dlg.DoModal() != IDOK) return;

	// Add the new shape
	if (dlg.m_pShape) {
		ASSERT(m_pScene);
		m_pScene->AddChild(dlg.m_pShape);
		m_pScene->m_ShapeList.Append(dlg.m_pShape);
		MakeCurrent(dlg.m_pShape);
	}
}

///////////////////////////////////////////////////////////////
// Format a string for the status bar

void CMainFrame::Status(const char* pszFormat, ...)
{
	char buf[256];
	va_list arglist;
	va_start(arglist, pszFormat);
    vsprintf(buf, pszFormat, arglist);
	va_end(arglist);
	m_wndStatusBar.SetWindowText(buf);
	m_wndStatusBar.UpdateWindow();
}

/////////////////////////////////////////////////////////////
// Transform dialog

// callback from the dialog	when it closes
// static
void CMainFrame::OnCloseTrfmDlg(void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	pThis->m_pTransDlg = NULL;
}

// callback from the dialog to get a frame to control
// static
C3dFrame* CMainFrame::OnGetFrame(void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	return pThis->m_pCurShape;
}

void CMainFrame::ShowTrfmDlg()
{
	ASSERT(m_pCurShape);
	if (m_pTransDlg) {
		m_pTransDlg->BringWindowToTop();
	} else {
		m_pTransDlg = new CTransformDlg("Transforms",
										OnCloseTrfmDlg,
										OnGetFrame,
										this);
	}
}

void CMainFrame::OnEditTransform() 
{
	ShowTrfmDlg();
}

void CMainFrame::OnUpdateEditTransform(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

//////////////////////////////////////////////////////////////
// Control device selection

void CMainFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CFrameWnd::OnSetFocus(pOldWnd);
	
	// Give the focus to the 3D window so it can process
	// keystrokes for the key input device
	m_wnd3d.SetFocus();
}

// callback from the dialog to get a frame to control
// static
C3dFrame* CMainFrame::OnGetCtrlFrame(void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	if (pThis->m_iControlObj == 1) {
		return pThis->m_wnd3d.GetCamera();
	}
	return pThis->m_pCurShape;
}

void CMainFrame::OnEditControl() 
{
	CInpDevDlg dlg;
	dlg.m_iObject = m_iControlObj;
	dlg.m_iType = m_iControlType;
	dlg.m_iDevice = m_iObjCtrlDev;
	if (dlg.DoModal() != IDOK) return;
	m_iControlObj = dlg.m_iObject;

	// set up the controller type
	if (dlg.m_iType != m_iControlType) {

		if (m_pController) delete m_pController;

		// create a new controller
		m_iControlType = dlg.m_iType;
		if (m_iControlType == 0) {
			m_pController = new C3dPosCtlr;
		} else {
			m_pController = new C3dFlyCtlr;
		}
		m_pController->Create(&m_wnd3d,
							  OnGetCtrlFrame,
							  this);
	}

	ASSERT(m_pController);
	m_pController->SelectDevice(dlg.m_iDevice);
 	m_iObjCtrlDev = m_pController->GetCurDevice();
	Status("Control is now via: %s", 
		   m_pController->GetDeviceName(m_iObjCtrlDev));
}

void CMainFrame::OnUpdateEditControl(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pController ? TRUE : FALSE);
}

void CMainFrame::OnEditInputdev() 
{
	ASSERT(m_pController);
	C3dInputDevice* pDev = m_pController->GetInputDevice();
	ASSERT(pDev);
	pDev->ShowConfigDlg();
}

//////////////////////////////////////////////////////////////////
// Save and Restore Settings

void CMainFrame::SaveSettings()
{
	CWinApp* pa = AfxGetApp();
	pa->WriteProfileInt("Settings","ControlDevice", m_iObjCtrlDev);
	CRect rc;
	GetWindowRect(&rc);
	pa->WriteProfileInt("Settings\\Window","Top", rc.top);
	pa->WriteProfileInt("Settings\\Window","Left", rc.left);
	pa->WriteProfileInt("Settings\\Window","Width", rc.Width());
	pa->WriteProfileInt("Settings\\Window","Height", rc.Height());
	pa->WriteProfileInt("Settings\\Options","ViewSel", m_bViewSelection);
}

void CMainFrame::RestoreSettings()
{
	CWinApp* pa = AfxGetApp();
	m_iObjCtrlDev = pa->GetProfileInt("Settings","ControlDevice", 0);
	m_rcWnd.top = pa->GetProfileInt("Settings\\Window","Top", 50);
	m_rcWnd.left = pa->GetProfileInt("Settings\\Window","Left", 50);
	m_rcWnd.right = m_rcWnd.left + pa->GetProfileInt("Settings\\Window","Width", 300); 
	m_rcWnd.bottom = m_rcWnd.top + pa->GetProfileInt("Settings\\Window","Height", 350);
	m_bViewSelection = (BOOL) pa->GetProfileInt("Settings\\Options","ViewSel", 1);
}

//////////////////////////////////////////////////////////////////////////
// object selection

// callback notification function
// called by m_wnd3d when the object selection changes
// static
void CMainFrame::OnSelChange(C3dShape* pShape, CPoint pt, void* pArg)
{
	CMainFrame* pThis = (CMainFrame*) pArg;
	ASSERT(pThis);
	ASSERT(pThis->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	pThis->MakeCurrent(pShape);
}

void CMainFrame::MakeCurrent(C3dShape* pShape)
{
	if (pShape == m_pCurShape) {
		return;
	}
	HideSelection();
	m_pCurShape = pShape;
	ShowSelection();
	if (m_pCurShape != NULL) {
		Status("Selected: %s, %d faces",
			   m_pCurShape->GetName(),
			   m_pCurShape->GetFaceCount());
	} else {
		Status("No selection");
	}
}

void CMainFrame::ShowSelection()
{
	// Remove any existing selection
	HideSelection();

	if (!m_bViewSelection) {
		return;	// View Selection is disabled by the user
	}

	if (!m_pCurShape) {
		return; // Nothing selected
	}


	// get the bounding box of the shape
	double x1, x2, y1, y2, z1, z2;
	BOOL b = m_pCurShape->GetBox(x1, y1, z1, x2, y2, z2);
	ASSERT(b);

	// create a new selection box around the shape
	m_pSelBox = new C3dShape;

	double r = 0.03;
	double rc = r * 2;
	C3dShape r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12, rd, ru, cd, cu;
	r1.CreateRod(x1, y1, z1, x2, y1, z1, r);
	m_pSelBox->AddChild(&r1);
	r2.CreateRod(x1, y1, z1, x1, y2, z1, r);
	m_pSelBox->AddChild(&r2);
	r3.CreateRod(x1, y1, z1, x1, y1, z2, r);
	m_pSelBox->AddChild(&r3);
	r4.CreateRod(x1, y2, z1, x2, y2, z1, r);
	m_pSelBox->AddChild(&r4);
	r5.CreateRod(x2, y1, z1, x2, y2, z1, r);
	m_pSelBox->AddChild(&r5);
	r6.CreateRod(x1, y2, z1, x1, y2, z2, r);
	m_pSelBox->AddChild(&r6);
	r7.CreateRod(x2, y2, z1, x2, y2, z2, r);
	m_pSelBox->AddChild(&r7);
	r8.CreateRod(x2, y1, z1, x2, y1, z2, r);
	m_pSelBox->AddChild(&r8);
	r9.CreateRod(x1, y1, z2, x1, y2, z2, r);
	m_pSelBox->AddChild(&r9);
	r10.CreateRod(x1, y1, z2, x2, y1, z2, r);
	m_pSelBox->AddChild(&r10);
	r11.CreateRod(x2, y1, z2, x2, y2, z2, r);
	m_pSelBox->AddChild(&r11);
	r12.CreateRod(x1, y2, z2, x2, y2, z2, r);
	m_pSelBox->AddChild(&r12);

	rd.CreateRod(0, 0, 0, 0, 0, z2 + 2 * r, r);
	m_pSelBox->AddChild(&rd);
	cd.CreateCone(0, 0, z2 + 2 * r, rc, TRUE, 0, 0, z2 + 6 * r, 0, FALSE);
	m_pSelBox->AddChild(&cd);

	ru.CreateRod(0, 0, 0, 0, y2 + r, 0, r);
	m_pSelBox->AddChild(&ru);
 	cu.CreateCone(0, y2 + r, 0, rc, TRUE, 0, y2 + 3 * r, 0, 0, FALSE);
	m_pSelBox->AddChild(&cu);

	// Set the position and orientation of the box to
	// match the shape
	C3dStage* pStage = m_wnd3d.GetStage();

	double x, y, z, xd, yd, zd, xu, yu, zu;
	m_pCurShape->GetPosition(x, y, z, pStage);
	m_pCurShape->GetDirection(xd, yd, zd, xu, yu, zu, pStage);
	m_pSelBox->SetPosition(x, y, z, pStage);
	m_pSelBox->SetDirection(xd, yd, zd, xu, yu, zu, pStage);

	// Attach the selection box to the current shape
	// so it will move with it
	m_pCurShape->AddChild(m_pSelBox);
}

void CMainFrame::HideSelection()
{
	if (!m_pSelBox) {
		return; // No current selection
	}
	ASSERT(m_pCurShape);
	m_pCurShape->RemoveChild(m_pSelBox);
	delete m_pSelBox;
	m_pSelBox = NULL;
}

void CMainFrame::OnUpdateViewSelection(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bViewSelection);	
}

void CMainFrame::OnViewSelection() 
{
	m_bViewSelection = !m_bViewSelection;
	ShowSelection();
}

void CMainFrame::OnUpdateEditDeleteshape(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditDeleteshape() 
{
	ASSERT(m_pScene);
	ASSERT(m_pCurShape);
	C3dShape* pShape = m_pCurShape;
	MakeCurrent(NULL);
	m_pScene->RemoveChild(pShape);
	m_pScene->m_ShapeList.Delete(pShape);
}

///////////////////////////////////////////////////////////////////////////
// Object coloring

void CMainFrame::OnUpdateEditColor(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditColor() 
{
	ASSERT(m_pCurShape);
	CColorDialog dlg;
	if (dlg.DoModal() != IDOK) return;
	m_pCurShape->SetColor(GetRValue(dlg.m_cc.rgbResult) / 255.0,
						  GetGValue(dlg.m_cc.rgbResult) / 255.0,
						  GetBValue(dlg.m_cc.rgbResult) / 255.0);
}

void CMainFrame::OnUpdateEditRandcolor(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditRandcolor() 
{
	ASSERT(m_pCurShape);
	int iFaces = m_pCurShape->GetFaceCount();
	for (int i = 0; i < iFaces; i++) {
		m_pCurShape->SetFaceColor(i,
								  (rand() % 100) / 100.0,
								  (rand() % 100) / 100.0,
								  (rand() % 100) / 100.0);
	}
}

// Install a background image
void CMainFrame::OnEditBkgndImg() 
{
	C3dImage* pImg = new C3dImage;
	if (!pImg->Load()) {
		delete pImg;
		return;
	}

	ASSERT(m_pScene);
	m_pScene->m_ImgList.Append(pImg);
	m_pScene->SetBackground(pImg);
}

void CMainFrame::OnEditInstxface() 
{
	// create a shape with only one face and apply
	// a texture map to the face
	C3dShape* pShape = new C3dShape();

    D3DVECTOR vlist[] = {
        {-1.0, -1.0,  0.0},
        { 1.0, -1.0,  0.0},
        { 1.0,  1.0,  0.0},
        {-1.0,  1.0,  0.0}
    };
    int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);
    int iFaces[] = {4, 0, 3, 2, 1,  // front face
                    4, 0, 1, 2, 3,	 // back face
                    0};

    pShape->Create(vlist, iVectors, iFaces);

	// color the back face so we can identify it
	pShape->SetFaceColor(1, 0, 0, 1); // blue

	// Load the texture
	C3dTexture* pTex = new C3dTexture;
	if (!pTex->Load(IDB_G1)) {
		return;
	}
	m_pScene->m_ImgList.Append(pTex);

	// Attach the texture to the front face
	pShape->SetFaceTexture(0, pTex);

	// Create a wrap
	// Note: the face is 2x2 units so we scale the texture
	// so it fits exactly once. We also invert it so the 
	// texture map image comes out the right way up
	C3dWrap wrap;
    wrap.Create(D3DRMWRAP_FLAT,
				NULL,
				-1, -1, 0, // origin
				0, 0, 1, // direction
				0, 1, 0, // up
				0, pTex->GetHeight()-1,	 // texture origin
				0.5, -0.5);	 // texture scale (invert)

	// apply the wrap to just the front face
	wrap.Apply(pShape, 0);

	pShape->SetName("Face");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	MakeCurrent(pShape);

}

void CMainFrame::OnEditInsworld() 
{
	// Create a sphere for the planet
	C3dShape* pPlanet = new C3dShape;
	pPlanet->CreateSphere(2);

	// Load the texture map of the world
	C3dTexture* pTex1 = new C3dTexture;
	pTex1->Load(IDB_WORLD);
	m_pScene->m_ImgList.Append(pTex1);

	// Attach the texture to the shape
	pPlanet->SetTexture(pTex1);

	// Create a spherical wrap
	C3dWrap wrap;
    wrap.Create(D3DRMWRAP_SPHERE,
				NULL,
				0, 0, 0, // origin
				0, 0, 1, // direction
				0, 1, 0, // up
				0, 0,	 // texture origin
				1, 1);	 // texture scale

	// apply the wrap to the shapes
	wrap.Apply(pPlanet);

	pPlanet->SetDirection(0.5, 0.8, 0);

	pPlanet->SetName("World");
	m_pScene->AddChild(pPlanet);
	m_pScene->m_ShapeList.Append(pPlanet);
	MakeCurrent(pPlanet);
}

// Create a picture cube
// Note: you cannot apply different textures to faces with common
// vertices so we create 6 faces each with its own 4 vertices
void CMainFrame::OnEditPiccube() 
{
	// Create a 2 unit cube	with separate faces
	double s = 2;

	C3dShape* pShape = new C3dShape;

    D3DVECTOR vlist[] = {
        {-1.0, -1.0,  -1.0},
        { 1.0, -1.0,  -1.0},
        { 1.0, -1.0,   1.0},
        {-1.0, -1.0,   1.0}, // bottom

        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        {-1.0,  1.0,   1.0}, // top

        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        {-1.0,  1.0,   1.0},
        {-1.0, -1.0,   1.0}, // left

        { 1.0, -1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0}, // right

        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0, -1.0,  -1.0}, // front

        {-1.0, -1.0,   1.0},
        {-1.0,  1.0,   1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0}  // back

    };
    int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);
    int iFaces[] = {4, 0, 1, 2, 3,
                    4, 4, 7, 6, 5,
					4, 8, 11, 10, 9,
					4, 12, 13, 14, 15,
					4, 16, 17, 18, 19,
					4, 20, 23, 22, 21,
                    0};

    pShape->Create(vlist, iVectors, iFaces);

	for (int i = 0; i < 6; i++) {

		// load the texture map
		char buf[64];
		sprintf(buf, "g%d.bmp", i+1);
		C3dTexture* pTex = new C3dTexture;
		m_pScene->m_ImgList.Append(pTex);
		if (pTex->Load(IDB_G1+i)) {

			// Attach the texture to the face
			pShape->SetFaceTexture(i, pTex);

			// Get the face normal
			C3dVector vn = pShape->GetFaceNormal(i);

			// reverse it so it represents the wrap direction
			vn = -vn;

			// Compute an arbitrary up vector
			C3dVector vu = vn.GenerateUp();

			// Create a wrap oriented to this face
			C3dWrap wrap;
			wrap.Create(D3DRMWRAP_FLAT,
						NULL,
						-s/2, -s/2, -s/2, // origin
						vn.x, vn.y, vn.z, // direction
						vu.x, vu.y, vu.z, // up
						0, pTex->GetHeight()-1,	 // texture origin
						1.0/s, -1.0/s);	 // texture scale (invert)

			// apply the wrap to the face
			wrap.Apply(pShape, i);
		}
	}

	pShape->SetName("Picture cube");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	MakeCurrent(pShape);
}

void CMainFrame::OnEditTree() 
{
	// load the texture maps
	C3dTexture* pTex1 = new C3dTexture;
	pTex1->Load(IDB_LEAVES);
	m_pScene->m_ImgList.Append(pTex1);
	C3dTexture* pTex2 = new C3dTexture;
	pTex2->Load(IDB_BARK);
	m_pScene->m_ImgList.Append(pTex2);

	// Create a cylindrical wrap
	C3dWrap wrap;
	wrap.Create(D3DRMWRAP_CYLINDER,
				NULL,
				0, 0, 0, // origin
				0, 0, 1, // direction
				0, 1, 0, // up
				0, 0,	 // texture origin
				1, 1);	 // texture scale


	// Create the tree and its trunk
	double h = (rand() % 100) / 50.0 + 1.0;
	double x = ((rand() % 100) - 50) / 10.0;
	double z = ((rand() % 100) - 50) / 10.0;
	double y = -2;

	C3dShape* pTree = new C3dShape;
	pTree->CreateCone(x, y+h/4, z, h/4, TRUE,
					  x, y+h, z, 0, FALSE);
	m_pScene->m_ShapeList.Append(pTree);
	C3dShape* pTrunk = new C3dShape;
	pTrunk->CreateRod(x, y, z,
					  x, y+h/4, z,
					  h/20);
	m_pScene->m_ShapeList.Append(pTrunk);
	pTree->AddChild(pTrunk);

	// apply the textures
	pTree->SetTexture(pTex1);
	wrap.Apply(pTree);

	pTrunk->SetTexture(pTex2);
	wrap.Apply(pTrunk);

	pTree->SetName("Tree");
	m_pScene->AddChild(pTree);

	MakeCurrent(pTree);
}

//////////////////////////////////////////////////////////////////////////////////////
// Cloning a shape

void CMainFrame::OnUpdateEditClone(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnEditClone() 
{
	ASSERT(m_pCurShape);
	C3dShape* pClone = m_pCurShape->Clone();
	m_pScene->m_ShapeList.Append(pClone);
	m_pScene->AddChild(pClone);
	MakeCurrent(pClone);
}

////////////////////////////////////////////////////////////////////////////////////
// Build a house by combining shapes

void CMainFrame::OnEditHouse() 
{
	// load the texture maps
	C3dTexture* pBricks = new C3dTexture;
	pBricks->Load(IDB_BRICKS);
	m_pScene->m_ImgList.Append(pBricks);
	C3dTexture* pTiles = new C3dTexture;
	pTiles->Load(IDB_TILES);
	m_pScene->m_ImgList.Append(pTiles);

	// Create a cylindrical wrap for the bricks
	C3dWrap bwrap;
	bwrap.Create(D3DRMWRAP_CYLINDER,
				 NULL,
				 0, 0, 0, // origin
				 0, 1, 0, // direction
				 0, 0, 1, // up
				 0, 0,	 // texture origin
				 10, 10);	 // texture scale

	// Create a flat wrap for the tiles
	C3dWrap twrap;
	twrap.Create(D3DRMWRAP_FLAT,
				 NULL,
				 0, 0, 0, // origin
				 0, 1, 0, // direction (y)
				 0, 0, 1, // up	(z)
				 0, 0,	 // texture origin
				 10, 10);	 // texture scale

	// Create the house shape
	C3dShape* pHouse = new C3dShape;

    D3DVECTOR hvlist[] = {
        {-0.5,  0.0,  -0.4},
        {-0.5,  0.65, -0.4},
        {-0.5,  0.85,  0.0},
        {-0.5,  0.65,  0.4},
        {-0.5,  0.0,   0.4},

        { 0.5,  0.0,  -0.4},
        { 0.5,  0.65, -0.4},
        { 0.5,  0.85,  0.0},
        { 0.5,  0.65,  0.4},
        { 0.5,  0.0,   0.4},

    };
    int iHVectors = sizeof(hvlist) / sizeof(D3DVECTOR);
    int iHFaces[] = {5, 0, 4, 3, 2, 1,
                     4, 0, 1, 6, 5,
					 5, 5, 6, 7, 8, 9,
					 4, 9, 8, 3, 4,
                     0};

    pHouse->Create(hvlist, iHVectors, iHFaces);
	m_pScene->m_ShapeList.Append(pHouse);

	// Create the roof shape
	C3dShape* pRoof = new C3dShape;

    D3DVECTOR rvlist[] = {
        {-0.6,  0.6,  -0.5},
        {-0.6,  0.85,  0.0},
        {-0.6,  0.6,   0.5},

        { 0.6,  0.6,  -0.5},
        { 0.6,  0.85,  0.0},
        { 0.6,  0.6,   0.5},

    };
    int iRVectors = sizeof(rvlist) / sizeof(D3DVECTOR);
    int iRFaces[] = {4, 0, 1, 4, 3,
                     4, 1, 2, 5, 4,
                     0};

    pRoof->Create(rvlist, iRVectors, iRFaces);

	// apply the house texture 
	pHouse->SetTexture(pBricks);
	bwrap.Apply(pHouse);

	// apply the roof texture
	pRoof->SetTexture(pTiles);
	twrap.Apply(pRoof);

	// Add the roof to the house
	pRoof->SetName("Roof");
	pHouse->AddChild(pRoof);
	m_pScene->m_ShapeList.Append(pRoof);

	pHouse->SetName("House");
	m_pScene->AddChild(pHouse);
	MakeCurrent(pHouse);
}


// Create several objects from a common mesh and color them differently
// by setting the frame as the material source
void CMainFrame::OnEditClrframe() 
{
	// Create a sphere for the first shape
	C3dShape* pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetColor(1, 0, 0); // red
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	MakeCurrent(pShape);
	pShape->SetName("Red master");

	// Create a clone 
	C3dShape* pClone1 = m_pCurShape->Clone();
	m_pScene->m_ShapeList.Append(pClone1);
	m_pScene->AddChild(pClone1);
	pClone1->SetPosition(-2, 0, 0);

	// Set the color of the clone's frame
	pClone1->SetMaterialMode(D3DRMMATERIAL_FROMFRAME);
	pClone1->SetFrameColor(0, 1, 0); // green
	pClone1->SetName("Green clone");

	// Create a clone 
	C3dShape* pClone2 = m_pCurShape->Clone();
	m_pScene->m_ShapeList.Append(pClone2);
	m_pScene->AddChild(pClone2);
	pClone2->SetPosition(2, 0, 0);

	// Set the color of the clone's frame
	pClone2->SetMaterialMode(D3DRMMATERIAL_FROMFRAME);
	pClone2->SetFrameColor(0, 0, 1); // blue
	pClone2->SetName("Blue clone");

	// Create a clone 
	C3dShape* pClone3 = m_pCurShape->Clone();
	m_pScene->m_ShapeList.Append(pClone3);
	m_pScene->AddChild(pClone3);
	pClone3->SetPosition(0, 2, 0);

	// Set the color of the clone's frame
	pClone3->SetMaterialMode(D3DRMMATERIAL_FROMFRAME);
	pClone3->SetFrameColor(0, 1, 1); // cyan
	pClone3->SetName("Cyan clone");
}

void CMainFrame::OnEditMaterials() 
{
	// Create some shapes with different material properties
	// Normal
	C3dShape* pShape = new C3dShape;
	pShape->CreateSphere(1);
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(-2, 2, 0);
	pShape->SetName("Normal");

	// Red light emitter
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Red emitter");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(0, 2, 0);
	C3dMaterial m1;
	m1.SetEmissiveColor(1, 0, 0);
	pShape->SetMaterial(&m1);

	// red emitter
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Red emitter");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(2, 2, 0);
	C3dMaterial m2;
	m2.SetEmissiveColor(1, 0, 0);
	m2.SetSpecularPower(400);
	pShape->SetMaterial(&m2);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 3");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(-2, 0, 0);
	C3dMaterial m3;
	m3.SetSpecularPower(3);
	pShape->SetMaterial(&m3);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 10");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(0, 0, 0);
	C3dMaterial m4;
	m4.SetSpecularPower(10);
	pShape->SetMaterial(&m4);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 50");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(2, 0, 0);
	C3dMaterial m5;
	m5.SetSpecularPower(50);
	pShape->SetMaterial(&m5);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 100");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(-2, -2, 0);
	pShape->SetColor(1, 0, 0);
	C3dMaterial m6;
	m6.SetSpecularPower(100);
	pShape->SetMaterial(&m6);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 500");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(0, -2, 0);
	pShape->SetColor(1, 0, 0);
	C3dMaterial m7;
	m7.SetSpecularPower(500);
	pShape->SetMaterial(&m7);

	// power effects
	pShape = new C3dShape;
	pShape->CreateSphere(1);
	pShape->SetName("Specular power 2000");
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	pShape->SetPosition(2, -2, 0);
	pShape->SetColor(1, 0, 0);
	C3dMaterial m8;
	m8.SetSpecularPower(2000);
	pShape->SetMaterial(&m8);

}

void CMainFrame::OnEditChrome() 
{
	// Load a shape to play with
	C3dShape* pShape = new C3dShape;
	if (!pShape->Load()) {
		delete pShape;
		return;
	}

	NewScene();
	ASSERT(m_pScene);
	
	// Create a chrome wrap
	m_pChromeWrap = new C3dChromeWrap;
	m_pChromeWrap->Create(pShape, m_wnd3d.GetStage()->GetCamera());

	// Load the scene background
	C3dImage* pImg = new C3dImage;
	pImg->Load(IDB_CHROME);
	m_pScene->m_ImgList.Append(pImg);
	m_pScene->SetBackground(pImg);
	
	// load the texture map
	C3dTexture* pTex = new C3dTexture;
	pTex->Load(IDB_CHROME);
	m_pScene->m_ImgList.Append(pTex);

	// apply the texture 
	pShape->SetTexture(pTex);

	// Make it more shiny
	C3dMaterial mat;
	mat.SetSpecularPower(2000);
	pShape->SetMaterial(&mat);

	// Add the new shape
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	MakeCurrent(pShape);

	// Spin it around a bit
	pShape->SetRotation(1, 1, 1, 0.03);

}

void CMainFrame::OnEditTank() 
{
	C3dShape* pShape = new C3dShape;
	BOOL b = pShape->Load(IDX_TANK);
	ASSERT(b);
	ASSERT(m_pScene);
	m_pScene->AddChild(pShape);
	m_pScene->m_ShapeList.Append(pShape);
	MakeCurrent(pShape);
}

///////////////////////////////////////////////////////////////////////
// Saving various things

// Save the current rendered scene
void CMainFrame::OnFileSaveImage() 
{
	// Get a pointer to the Direct Draw object in the 3D window
	CDirectDraw* pDD = m_wnd3d.GetDD();
	ASSERT(pDD);

	// Grab the current image
	BITMAPINFO* pBMI = NULL;
	BYTE* pBits = NULL;
	HBITMAP hBmp = pDD->GrabImage(&pBMI, (void**)&pBits);
	if (!hBmp) {
		AfxMessageBox("Failed to grab rendered image");
		return;
	}
	ASSERT(pBMI);
	ASSERT(pBits);

	// Save the image to a bitmap file
    // Show a File Save dialog to get the name.
    CFileDialog dlg   (FALSE,   // Save
                       NULL,    // No default extension
                       NULL,    // No initial file name
                       OFN_OVERWRITEPROMPT
                         | OFN_HIDEREADONLY,
                       "Bitmap files (*.BMP)|*.BMP|All files (*.*)|*.*||");
    if (dlg.DoModal() == IDOK) {

		if (!DIBSave(dlg.GetPathName(), pBMI, pBits)) {
			AfxMessageBox("Failed to save file");
		}
	}

	// tidy up
	delete pBMI;
	::DeleteObject(hBmp);
}

void CMainFrame::OnUpdateFileSaveObject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurShape != NULL);
}

void CMainFrame::OnFileSaveObject() 
{
	ASSERT(m_pCurShape);
	if (!m_pCurShape->Save()) {
		AfxMessageBox("Save failed");
	}
}
